


#include	"std.h"
#include	"code.h"



/*
##typespec read : unique
##*/
	int readProg ();


/*
##typedef read : unique
##*/
#define	OpdNumMax	3
#define	BufSize		256

	/*
	##typespec macro : value
	##*/
#define		McStart	-1
#define		McEnd	-2
#define		McDs	-3
#define		McDc	-4

	/*
	##typespec opdType : value
	##*/
#define		OpdGr	1
#define		OpdXr	3
#define		OpdAdr	2
#define		OpdAdr2	4
#define		OpdDc	5

	typedef struct {
		int	Cd;
		char	*Opr;
		int	Opd[OpdNumMax];
	} NTAB;
	static NTAB ntab[] = {
		{CdLd,		"LD",	OpdGr, OpdAdr, OpdXr},
		{CdSt,		"ST",	OpdGr, OpdAdr, OpdXr},
		{CdLea,		"LEA",	OpdGr, OpdAdr, OpdXr},
		{CdAdd,		"ADD",	OpdGr, OpdAdr, OpdXr},
		{CdSub,		"SUB",	OpdGr, OpdAdr, OpdXr},
		{CdAnd,		"AND",	OpdGr, OpdAdr, OpdXr},
		{CdOr,		"OR",	OpdGr, OpdAdr, OpdXr},
		{CdEor,		"EOR",	OpdGr, OpdAdr, OpdXr},
		{CdCpa,		"CPA",	OpdGr, OpdAdr, OpdXr},
		{CdCpl,		"CPL",	OpdGr, OpdAdr, OpdXr},
		{CdSla,		"SLA",	OpdGr, OpdAdr, OpdXr},
		{CdSra,		"SRA",	OpdGr, OpdAdr, OpdXr},
		{CdSll,		"SLL",	OpdGr, OpdAdr, OpdXr},
		{CdSrl,		"SRL",	OpdGr, OpdAdr, OpdXr},
		{CdJpz,		"JPZ",	OpdAdr, OpdXr},
		{CdJmi,		"JMI",	OpdAdr, OpdXr},
		{CdJnz,		"JNZ",	OpdAdr, OpdXr},
		{CdJze,		"JZE",	OpdAdr, OpdXr},
		{CdJmp,		"JMP",	OpdAdr, OpdXr},
		{CdPush,	"PUSH",	OpdAdr, OpdXr},
		{CdPop,		"POP",	OpdGr},
		{CdCall,	"CALL",	OpdAdr, OpdXr},
		{CdRet,		"RET",	},
		{CdIn,		"IN",	OpdAdr, OpdAdr2},
		{CdOut,		"OUT",	OpdAdr, OpdAdr2},
		{CdExit,	"EXIT",	},
		{CdOutInt,	"OUTINT",OpdAdr, OpdXr},
		{CdMul,		"MUL",	OpdGr, OpdAdr, OpdXr},
		{CdDiv,		"DIV",	OpdGr, OpdAdr, OpdXr},
		{McStart,	"START",OpdAdr},
		{McEnd,		"END",	},
		{McDs,		"DS",	OpdAdr},
		{McDc,		"DC",	OpdDc},
		{Null}
	};

	static char buf[BufSize+1];
	static char *bp[OpdNumMax+2];

	static void wordGet ();
	static NTAB *ntabSrc ();
	static void checkLabel ();
	static int getReg ();
	static int getAdr ();
	static void getAddc ();

	int readProg () {
		NTAB *n;
		int stAdr;
		bool exit;
		int gr, xr, adr, adr2;
		int addc[100];
		int line, i;

		errSet("syntax error in line %d", &line);
		stAdr = Null;	exit = False;  line = 0;
		while (sioGetS(buf, BufSize)) {
			line++;
			wordGet();

		/* label */
			if (bp[0][0]) {
				checkLabel(bp[0]);
				atabSet(bp[0], progGetLast());
			}
			if (!bp[1][0]) continue;

		/* opelator */
			n = ntabSrc(bp[1]);
			if (!n) {
				continue;
			}

		/* opeland */
			gr = xr = -1;
			adr = adr2 = Null;
			for (i = 0; i < OpdNumMax; i++) switch (n->Opd[i]) {
			case OpdGr:
				gr = getReg(bp[i+2]);
				break;
			case OpdXr:
				if (bp[i+2][0]) {
					xr = getReg(bp[i+2]);
					if (xr == 0) {
					    errPutS("non index register (GR0)");
					}
				}
				break;
			case OpdAdr:
				if (bp[i+2][0] || n->Cd != McStart) {
					adr = getAdr(bp[i+2]);
				}
				break;
			case OpdAdr2:
				adr2 = getAdr(bp[i+2]);
				break;
			case OpdDc:
				if (bp[i+2][0] == '\'') {
					getAddc(bp[i+2], addc);
				}
				else {
					addc[0] = getAdr(bp[i+2]);
					addc[1] = Null;
				}
				break;
			default:
				if (bp[i+2][0]) {
				    errPutS("too many operand (%s)", bp[i+2]);
				}
			}

			if (n->Cd == McStart) {
				stAdr = adr;
			}
			else if (n->Cd == McEnd) {
				break;
			}
			else if (n->Cd == McDs) {
				progPutS(atabGet(adr));
			}
			else if (n->Cd == McDc) {
				for (i = 0; addc[i]; i++) progPutD(addc[i]);
			}
			else if (n->Cd == CdExit) {
				progPut(n->Cd, gr, adr, xr, adr2);
				exit = True;
			}
			else {
				progPut(n->Cd, gr, adr, xr, adr2);
			}
		}
		if (!exit) {
			errPutS("no EXIT");
		}
		return (stAdr);
	}

	static void checkLabel (label) char *label; {
		char *p;

		p = label;
		if (*p < 'A' || 'Z' < *p) {
			errPutS("illegal label (%s)", label);
		}
		else for (p++; *p; p++) {
			if ((*p < 'A' || 'Z' < *p) &&
			    (*p < '0' || '9' < *p)) {
				errPutS("illegal label (%s)", label);
				break;
			}
		}
		if (strlen(label) > 6) {
			errPutS("too long label (%s)", label);
		}
	}

	static int getReg (reg) char *reg; {

		switch (strlen(reg)) {
		case 1:
			if ('0' <= reg[0] && reg[0] <= '4') {
				return (int)(reg[0]-'0');
			}
			break;
	/*	case 2:
			if (reg[0] == 'S' && reg[1] == 'P') {
				return (4);
			}
			break;
	*/	case 3:
			if (reg[0] == 'G' && reg[1] == 'R' &&
				'0' <= reg[2] && reg[2] <= '4') {
				return (int)(reg[2]-'0');
			}
			break;
		}
		errPutS("unrecognized register operand (%s)", reg);
		return (-1);
	}

	static int getAdr (bp) char *bp; {
		char *p;
		int adr, c, d, i;

		adr = Null;
		p = bp;  c = *p++;
		if (c == '-' || '0' <= c && c <= '9') {
			i = 1;
			if (c == '-') {
				i = -1;
				c = *p++;
			}
			d = 0;
			while (c) {
				if ('0' <= c && c <= '9') {
					d = d*10 + c-'0';
				}
				else {
				    errPutS("illegal integer operand (%s)", bp);
				    break;
				}
				c = *p++;
			}
			d *= i;
			if (d < -0x8000 || 0x10000 <= d) {
				errPutD("out of range integer (%d)", d);
			}
			adr = atabSetNum(d);
		}
		else if (c == '#') {
			c = *p++;
			d = 0;
			if (strlen(bp) != 5) {
				errPutS("illegal integer operand (%s)", bp);
			}
			else for (i = 0; i < 4; i++) {
				if ('0' <= c && c <= '9') {
					d = d*16 + c-'0';
				}
				else if ('A' <= c && c <= 'F') {
					d = d*16 + c-'A'+10;
				}
				else {
				    errPutS("illegal integer operand (%s)", bp);
				    break;
				}
				c = *p++;
			}
			adr = atabSetNum(d);
		}
		else if (c == '\'') {
			c = *p++;
			adr = atabSetNum(c);
			c = *p++;
			if (c != '\'') {
				errPutS("illegal character operand (%s)", bp);
			}
		}
		else if ('A' <= c && c <= 'Z') {
			checkLabel(bp);
			adr = atabSetLabel(bp);
		}
		else {
			errPutS("unrecognized address operand (%s)", bp);
		}
		return (adr);
	}

	static void getAddc (bp, addc) char *bp; int *addc; {
		int l;

		l = strlen(bp);
		if (bp[0] != '\'' || bp[l-1] != '\'') {
			errPutS("unrecognized constant (%s)", bp);
			*addc = Null;
			return;
		}
		for (bp++; *bp && *bp != '\''; bp++) {
			*addc++ = atabSetNum((int)*bp);
		}
		*addc = Null;
	}

	static NTAB *ntabSrc (opr) char *opr; {
		NTAB *n;

		for (n = ntab; n->Cd; n++) {
			if (!strcmp(n->Opr, opr)) return (n);
		}
		errPutS("unrecognized operator (%s)", opr);
		return (Null);
	}

	static void wordGet () {
		char *p;
		int c, i;

		if ((i = strlen(buf)) > 0 && buf[i-1] == '\n') buf[i-1] = '\0';
		p = buf;  c = *p++;
		for (i = 0; i < OpdNumMax+2; ) { 
			bp[i++] = p-1;
			if (c == '\'') {
				c = *p++;
				while (c && c != '\'') c = *p++;
				if (c == '\'') c = *p++;
				if (!c || c == ';') break;
				*(p-1) = '\0';
			}
			else {
				while (c && c != ' ' && c != '\t' &&
					c != ';' && c != ',') c = *p++;
				if (!c || c == ';') break;
				*(p-1) = '\0';
			}
			while (c == ' ' || c == '\t') c = *p++;
			if (i >= 3) {
				if (c == ',') c = *p++;
				while (c == ' ' || c == '\t') c = *p++;
			}
			if (!c || c == ';') break;
		}
		if (c && c != ';') {
			errPutS("unexpected symbol (%s)", p-1);
		}
		*(p-1) = '\0';
		for (; i < OpdNumMax+2; ) {
			bp[i++] = p-1;
		}
	}


