/*
##	sio.c : Standard I/O Manager
##	22-Jun-88  by Y.Takada
##*/

#include	<stdio.h>
#include	"std.h"

/*
##typespec sio : unique
##*/
	void sioSetIn ();
	int sioGetC ();
	bool sioGetS ();
	void sioPutC ();
	void sioPutS ();
	void errPut ();
	void errPutS ();


/*
##typedef sio : unique
##*/

	static FILE *rdStr;

	/*
	##sioSetIn
	##*/
	void sioSetIn (path) char *path; {

		if (!path) {
			rdStr = stdin;
			}
		else {
			if (rdStr && rdStr != stdin) {
				fclose(rdStr);
				}
			rdStr = fopen(path, "r");
			}
		}

	/*
	##sioGetC
	##*/
	int sioGetC () {
		int c;

		if (!rdStr) return (Error);
		c = fgetc(rdStr);
		return (c);
		}

	/*
	##sioGetS
	##*/
	bool sioGetS (s, n) char *s; int n; {

		if (!rdStr) return (False);
		return (fgets(s, n+1, rdStr) != Null);
		}

	/*
	##sioPutC
	##*/
	void sioPutC (c) char c; {

		fputc(c, stdout);
		}

	/*
	##sioPutS
	##*/
	void sioPutS (s) char *s; {

		fputs(s, stdout);
		}



	static int errCnt;
	static char *errTitle = "";
	static int *errP = &errCnt;

	/*
	##errSet
	##*/
	void errSet (title, p) char *title; int *p; {

		errTitle = title;
		errP = p;
	}

	/*
	##errPutD
	##*/
	void errPutD (f, d) char *f; int d; {

		fprintf(stderr, "-- ");
		fprintf(stderr, errTitle, *errP);
		fprintf(stderr, "\n\t");
		fprintf(stderr, f, d);
		fprintf(stderr, "\n");
		if (++errCnt >= 10) {
			fprintf(stderr, "-- too many errors\n");
			exit(1);
			}
		}

	/*
	##errPutS
	##*/
	void errPutS (f, s) char *f, *s; {

		fprintf(stderr, "-- ");
		fprintf(stderr, errTitle, *errP);
		fprintf(stderr, "\n\t");
		fprintf(stderr, f, s);
		fprintf(stderr, "\n");
		if (++errCnt >= 10) {
			fprintf(stderr, "-- too many errors\n");
			exit(1);
			}
		}

